use serde::{Deserialize, Serialize};

use crate::s2s::Dispatch;

#[derive(Debug, Serialize, Deserialize)]
#[serde(tag = "t", content = "d", rename_all = "SCREAMING_SNAKE_CASE")]
pub enum Payload {
    #[serde(rename = "D")]
    Dispatch {
        #[serde(rename = "e")]
        event: Dispatch,
        #[serde(rename = "s")]
        server_id: String,
    },
    Error {
        message: String,
    },
    /// Hello message, sent after authentication succeeds
    Hello {
        guilds: Vec<String>,
    },
    Identify {
        token: String,
    },
}
